\documentclass[11pt,a4paper]{article}

\input{preambule.tex}

\addbibresource{Fourier_POP.bib}

\begin{document}
\section{preliminary}
\subsection{Maximizing absolute value}
The problem :
\begin{equation}\label{eq:max absf}
    \begin{array}{cc}
        \underset{x}{\max} & |f(x)|  \\
         \text{ s.t. } & x\in X
    \end{array}
\end{equation}
is equivalent to the semi-infinite programming problem:
\begin{equation}
    \begin{array}{cc}
        \underset{\theta}{\min} & \theta  \\
         \text{ s.t. } & \forall x\in X\left\{\begin{array}{l}\theta\geq f(x)\\\theta\geq-f(x)\end{array}\right.
    \end{array}
\end{equation}

\subsection{Positive certificate of trigonometric polynomial}
We call trigonometric polynomial a Laurent complex polynomial $\mathbb{C}[z,z^{-1}]$ restricted to $\mathbb{T}^d$ and taking real value on $\mathbb{T}^d$. We allow negative exponent of $z$.

For $d\geq 3$, a trigonometric polynomial is \textit{strictly positive} \textit{iff} it's sos.

Fof $d=1,2$, a trigonometric polynomial is \textit{nonnegative} \textit{iff} it's sos.

The nonnegativeness certificate for trigonometric polynomial is stronger than real polynomial whose SOS nonnegativeness certificate holds only for $d=1$. And there is not $g_i$ so the degree of SOS polynomial is bounded by the degree of the polynomial ! (Exact Lasserre hierarchy at first relaxation !)

\textcolor{red}{Erratum : For $d=1$, a trigonometric polynomial is nonnegative iff it's sos and the degree of the sos is the same as the degree of the polynomial. For $d=2$, yes but the degree of the sos is unknown, so there is still a Hierarchy of SOS relaxation that is garanteed to converge finitely. In $d=1$, the first SOS relaxation is tight, already. And I'm not sure about the connection between the degree and the presence of $g_i$.}

\textcolor{red}{So in general, we still need Hierarchy of SOS relaxation for optimizing trigonometric polynomial. There seems to be a strong result about the convergence rate (exponential with respect the level of relaxation) but I need to check the paper. See \cite{bach_exponential_2023}}

\section{Main problem}
\subsection{Min-max formulation}
\begin{equation}\label{eq:main}
	\begin{array}{cc}
		\underset{a,c_m(V)}{\min} ~&~ \underset{t}{\max}|f(t)^TV(t)| \\
		\text{s.t. }&\left\{\begin{array}{c}
			Q^Ta\leq M, K(a)\succeq 0,M(a)\succeq 0, K_N(a)\succeq 0\\
			K_m(a)c_m(V)=imc_m(f)
		\end{array}\right.
	\end{array}
\end{equation}

Where $f(t)^TV(t)=\sum_{n,m}c_n(f)^Tc_m(V)e^{i(n+m)t}=\sum_{n,m}c_n(f)^Tc_m(V)z^{n+m}$ for all $t\in[-\pi,\pi],z\in\mathbb{T}$.
\subsection{Semi infinite reformulation}
By the result in section 1.1, we transform the min-max problem into a semi-infinite programming:
\begin{equation}\label{eq:semi inf}
	\begin{array}{cc}
		\underset{a,c_m(V),\theta}{\min} ~&~ \theta \\
		\text{s.t. }&\left\{\begin{array}{c}
			Q^Ta\leq M,K(a)\succeq 0,M(a)\succeq 0, K_N(a)\succeq 0\\
			K_m(a)c_m(V)=imc_m(f)\\
			\theta-\sum_{n,m}c_n(f)^Tc_m(V)z^{n+m}\geq 0,\forall z\in\mathbb{T}\\
			\theta+\sum_{n,m}c_n(f)^Tc_m(V)z^{n+m}\geq 0,\forall z\in\mathbb{T}
		\end{array}\right.
	\end{array}
\end{equation}
Semi-infinite because there are an infinity numbers of constraints involving $\theta$, this is tackled by nonnegative certificate of trigonometric polynomial on $\mathbb{T}$ and will be equivalent to a SDP constraint.

\subsection{SDP reformulation}
Based on semi-inifinite reformulation, we rewrite the semi-inifinite constraint by SDP constraint as it is equivalent of certifying if a trigonometric polynomail is SOS.

\begin{equation}\label{eq:sdp-cmv}
	\begin{array}{cc}
		\underset{a,\theta,\mathcal{Q}_1,\mathcal{Q}_2,c_m(V)}{\min} & \theta\\
		\text{ s.t. } & \left\{\begin{array}{l}
			Q^Ta\leq M, -N^2M(a)+K(a)\succeq 0, M(a)\succeq 0\\
			K_m(a)c_m(V)=imc_m(f),\forall m\geq 0\\
			\theta=\tr\paren{\mathcal{Q}_1}=\tr\paren{\mathcal{Q}_2}\\
			\sum_{n+m=l}c_n(f)^Tc_m(V)=\tr\paren{\Lambda_{l,2N+1}\mathcal{Q}_1}=-\tr\paren{\Lambda_{l,2N+1}\mathcal{Q}_2},\forall l\geq 1\\
			\mathcal{Q}_1\succeq 0, \mathcal{Q}_2\succeq 0
		\end{array}\right.
	\end{array}
\end{equation}

\subsection{Bilevel POP reformuation}
Finally we introduce bilevel POP reformulation to remove variables $c_m(V)$ from optimization variables. The cost to pay is now we have lower level optimization problem with PMI constraint.

Finally, we have:

\begin{equation}
	\begin{array}{cc}
		\underset{a,\theta,\mathcal{Q}_1,\mathcal{Q}_2,\gamma^i}{\min} ~&~ \theta\\
		\text{ s.t. }&\left\{\begin{array}{l}
			Q^Ta\leq M,K_N(a)\succeq 0, M(a)\succeq 0, K(a)\succeq 0\\
			\theta=\tr\paren{\mathcal{Q}_1}=\tr\paren{\mathcal{Q}_2}\\
			\lambda^*\gamma_l=\tr\paren{\Lambda_{l,2N+1}\mathcal{Q}_1}=-\tr\paren{\Lambda_{l,2N+1}\mathcal{Q}_2},\forall l\geq 1\\
			\mathcal{Q}_1\succeq0,\mathcal{Q}_2\succeq0\\
			(\gamma^i)\in\Gamma(a)=\argmin\set{\dots}
		\end{array}\right.
	\end{array}
\end{equation}

$\gamma^i$ are in the constraint set such that for $l\in\set{1,\dots,2N}$: 
\begin{align*}
	&\gamma_l^1=\argmin\set{\gamma\mid\begin{pmatrix}\gamma&\paren{a_{l-m}(f)+ma_{m}(f)}^T\\.&\mathcal{K}_l(a)\end{pmatrix}\succeq0}\\
	&\gamma_l^2=\argmin\set{\gamma\mid\begin{pmatrix}\gamma&\paren{a_{l-m}(f)+mb_{m}(f)}^T\\.&\mathcal{K}_l(a)\end{pmatrix}\succeq0}\\
	&\gamma_l^3=\argmin\set{\gamma\mid\begin{pmatrix}\gamma&\paren{b_{l-m}(f)+ma_{m}(f)}^T\\.&\mathcal{K}_l(a)\end{pmatrix}\succeq0}\\	
	&\gamma_l^4=\argmin\set{\gamma\mid\begin{pmatrix}\gamma&\paren{b_{l-m}(f)+mb_{m}(f)}^T\\.&\mathcal{K}_l(a)\end{pmatrix}\succeq0}\\	
	&\gamma_l^5=\argmin\set{\gamma\mid\begin{pmatrix}\gamma&\paren{a_{l-m}(f)}^T\\.&\mathcal{K}_l(a)\end{pmatrix}\succeq0}\\
	&\gamma_l^6=\argmin\set{\gamma\mid\begin{pmatrix}\gamma&\paren{ma_{m}(f)}^T\\.&\mathcal{K}_l(a)\end{pmatrix}\succeq0}\\
	&\gamma_l^7=\argmin\set{\gamma\mid\begin{pmatrix}\gamma&\paren{b_{l-m}(f)}^T\\.&\mathcal{K}_l(a)\end{pmatrix}\succeq0}\\
	&\gamma_l^8=\argmin\set{\gamma\mid\begin{pmatrix}\gamma&\paren{mb_{m}(f)}^T\\.&\mathcal{K}_l(a)\end{pmatrix}\succeq0}
\end{align*}

$\mathcal{Q}$ is complex Hermitian of size $(2N+1)\times (2N+1)$,$\gamma^i$ for $i\in\{1,\dots,8\}$ are real of length $2N$, each of the underlying PMI's dimension depends mainly on those of $\mathcal{K}_l(a)$. 

How to improve ? Use better "basis" matrices $\Lambda_{l,2N+1}$ (see theorem 2.25 of \cite{dumitrescu_positive_2017}) such that $\mathcal{Q}_i$ become real symmetric matrix and better symmetrization of $f^TM^\dagger g$ to obtain $\gamma^i$ with less dimension.

Total number of variables : $\#(a)+\#(\theta)+\#(\gamma^i)+\#(\mathcal{Q}_i)=r+1+16N+2\frac{2N(2N+1)}{2}\times2$, quadratic in number of harmonics $N$ !

Max degree = $\deg(K(a))$ and is constant. Since $K(a)$ is the only one that is supposed to have higher degree.

Number of variables and max degree are independant of discretiztion level of $K(a)$ ! so it's less unmanageable than really unmanageable ...

\textcolor{red}{Here I forgot to mention that (1) $\lambda$ is a constant complex vector (2) $\mathcal{K}_l(a)$ are block diagonal matrices whose dimension depends on $l$ (3) $a_m(f),b_m(f)$ are the real and imaginary part of $c_m(f)$ and we stack them in a column vector. The matrices $\mathcal{K}_l(a)$ act on the column vector.}

\subsection{Reformulate Bilevel with real variables}
This formulation requires two sdp Hermitian matrix, to simply this, we can see the previous problem as :
\begin{equation}\label{eq:two step min}
	\begin{array}{cc}
		\underset{a,\theta,\gamma^i}{\min} & \mathcal{J}(\theta, \gamma^i)\\
		\text{ s.t. } & \left\{\begin{array}{l}
			Q^Ta\leq M, -N^2M(a)+K(a)\succeq 0, M(a)\succeq 0\\
			(\gamma^i)\in\Gamma(a)
		\end{array}\right.
	\end{array}
\end{equation}
where $\mathcal{J}$ stands for a parametric SDP problem :$$
	\mathcal{J}:\theta,\gamma^i\mapsto\begin{array}{cc}
		\underset{\mathcal{Q}_1,\mathcal{Q}_2}{\min} & \theta\\
		\text{ s.t. }& \left\{\begin{array}{l}
			\theta=\tr\paren{\mathcal{Q}_1}=\tr\paren{\mathcal{Q}_2}\\
			\lambda^*\gamma_l=\tr\paren{\Lambda_{l,2N+1}\mathcal{Q}_1}=-\tr\paren{\Lambda_{l,2N+1}\mathcal{Q}_2},\forall l\geq 1\\
			\mathcal{Q}_1\succeq 0, \mathcal{Q}_2\succeq 0\\
		\end{array}\right.
	\end{array}
$$
We look for a dual formulation of the parametric problem, with real varibles. \textcolor{red}{The number of the dual varibles is linearly porportional to the number of affine equality constraints which is, in our case, linear to number of harmonics. Strong duality ? Well it usually happens for SDP programming...} The complexity are found mainly in the constraints $\lambda^*\gamma_l=\tr\paren{\Lambda_{l,2N+1}\mathcal{Q}_1}=-\tr\paren{\Lambda_{l,2N+1}\mathcal{Q}_2}$, if we split $\lambda^*\gamma_l$ into real and imaginary part and use the fact that $\Lambda_{-l,d}=\Lambda_{l,d}^T$ and $\mathcal{Q}_i$ are Hermitian, we notice that:
\begin{align*}
	\Re\tr\paren{\Lambda_{l,2N+1}\mathcal{Q}_i}=\tr\paren{\frac{\Lambda_{l,2N+1}+\Lambda_{-l,2N+1}}{2}\mathcal{Q}_i}\\
	\Im\tr\paren{\Lambda_{l,2N+1}\mathcal{Q}_i}=\tr\paren{\frac{\Lambda_{l,2N+1}-\Lambda_{-l,2N+1}}{2i}\mathcal{Q}_i}
\end{align*}
As consequence, we can state the following equivalent problem:
\begin{equation}
	\begin{array}{cc}
		\underset{\mathcal{Q}_1,\mathcal{Q}_2}{\min} & \theta\\
		\text{ s.t. }& \left\{\begin{array}{l}
			\theta=\tr\paren{\mathcal{Q}_1}=\tr\paren{\mathcal{Q}_2}\\
			\Re\lambda^*\gamma_l=\tr\paren{\frac{\Lambda_{l,2N+1}+\Lambda_{-l,2N+1}}{2}\mathcal{Q}_1}=-\tr\paren{\frac{\Lambda_{l,2N+1}+\Lambda_{-l,2N+1}}{2}\mathcal{Q}_2},\forall l\geq 1\\
			\Im\lambda^*\gamma_l=\tr\paren{\frac{\Lambda_{l,2N+1}-\Lambda_{-l,2N+1}}{2i}\mathcal{Q}_1}=-\tr\paren{\frac{\Lambda_{l,2N+1}-\Lambda_{-l,2N+1}}{2i}\mathcal{Q}_2},\forall l\geq 1\\
			\mathcal{Q}_1\succeq 0, \mathcal{Q}_2\succeq 0\\
		\end{array}\right.
	\end{array}
\end{equation}
Whose dual is:
\begin{equation}
	\begin{array}{cc}
		\underset{\mu_0,\mu_1,z^1,\dots,z^4}{\max} & (1-\mu_0-\mu_1)\theta+\sum_{l=1}^{2N}(z^1_l+z^2_l)\Re\lambda^*\gamma_l+(z^3_l+z^4_l)\Im\lambda^*\gamma_l\\
		\text{ s.t. }& \left\{\begin{array}{l}
			\mu_0I-\sum_{l=1}^{2N}\frac{\Lambda_{l,2N+1}+\Lambda_{-l,2N+1}}{2}z_l^1+\frac{\Lambda_{l,2N+1}-\Lambda_{-l,2N+1}}{2i}z_l^3\succeq 0\\
			\mu_1I+\sum_{l=1}^{2N}\frac{\Lambda_{l,2N+1}+\Lambda_{-l,2N+1}}{2}z_l^2+\frac{\Lambda_{l,2N+1}-\Lambda_{-l,2N+1}}{2i}z_l^4\succeq 0
		\end{array}\right.
	\end{array}
\end{equation}
\textcolor{red}{If strong duality holds for each of the feasible $\theta,\gamma^i$}, $\mathcal{J}(\theta,\gamma^i)$ takes the same value as the dual and thus the problem (\ref{eq:two step min}) becomes:
\begin{equation}
	\begin{array}{cc}
		\underset{a,\theta,\gamma^i,\mu_i,z^i}{\min} & (1-\mu_0-\mu_1)\theta+\sum_{l=1}^{2N}(z^1_l+z^2_l)\Re\lambda^*\gamma_l+(z^3_l+z^4_l)\Im\lambda^*\gamma_l\\
		\text{ s.t. } & \left\{\begin{array}{l}
			Q^Ta\leq M, -N^2M(a)+K(a)\succeq 0, M(a)\succeq 0\\
			(\gamma^i)\in\Gamma(a)\\
			(\mu_i,z^i)\in Z(\theta,\gamma^i)=\argmax\{\dots\}
		\end{array}\right.
	\end{array}
\end{equation}

The number of variables is as consequence:$$\#(a)+\#(\theta)+\#(\gamma^i)+\#(\mu_i)+\#(z^i)=r+1+8\times 2N+2+4\times 2N$$
which is linear with respect to the number of harmonics. On the other hand, there are now two lower level optimizaiton problems for $\gamma^i$ and $\mu_i,z^i$.

\section{Example}
Let's take $N=2$ : $f(t)=c_{-2}(f)e^{-2it}+c_{-1}(f)e^{-it}+c_0(f)+c_1(f)e^{it}+c_2(f)e^{2it}$
\begin{align}
	\implies f(t)^Tv(t)=&\paren{c_{-2}(f)^Tc_{-2}{V}}e^{-4it}+\\
		&\paren{c_{-2}(f)^Tc_{-1}(V)+c_{-1}(f)^Tc_{-2}(V)}e^{-3it}+\\
		&\paren{c_{-2}(f)^Tc_{0}(V)+c_{-1}(f)^Tc_{-1}(V)+c_{0}(f)^Tc_{-2}(V)}e^{-2it}+\\
		&\paren{c_{-2}(f)^Tc_{1}(V)+c_{-1}(f)^Tc_{0}(V)+c_{0}(f)^Tc_{-1}(V)+c_{1}(f)^Tc_{-2}(V)}e^{-it}+\\
		&\paren{c_{-1}(f)^Tc_{2}(V)+c_{1}(f)^Tc_{0}(V)+c_{0}(f)^Tc_{1}(V)+c_{2}(f)^Tc_{-1}(V)}e^{it}+\\
		&\paren{c_{0}(f)^Tc_{2}(V)+c_{1}(f)^Tc_{1}(V)+c_{0}(f)^Tc_{2}(V)}e^{2it}+\\
		&\paren{c_{1}(f)^Tc_{2}(V)+c_{1}(f)^Tc_{2}(V)}e^{3it}+\\
		&\paren{c_{2}(f)^Tc_{2}{V}}e^{4it}
\end{align}

\printbibliography

\end{document}

